VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Color Spy Example"
   ClientHeight    =   1095
   ClientLeft      =   2115
   ClientTop       =   1695
   ClientWidth     =   4095
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1095
   ScaleWidth      =   4095
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   900
      Top             =   420
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   240
      Top             =   420
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   1560
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   360
      Width           =   2355
   End
   Begin VB.Frame Frame1 
      Caption         =   "Color Spy"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3975
      Begin VB.PictureBox Picture2 
         Height          =   495
         Left            =   780
         ScaleHeight     =   435
         ScaleWidth      =   495
         TabIndex        =   2
         Top             =   300
         Width           =   555
      End
      Begin VB.PictureBox Picture1 
         Height          =   495
         Left            =   120
         ScaleHeight     =   435
         ScaleWidth      =   495
         TabIndex        =   1
         Top             =   300
         Width           =   555
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Color Spy Example
' by PAT or JK
' Date 9.27.99
' E-Mail: patorjk@aol.com
' Webpage: www.patorjk.com

' This is an example on how to make a color spy.
' It's pretty much inspired by a program dos
' made.

' I originally wasn't going to make an example
' on this, but I has some people request it
' so I thought what the hell. This example
' shows you two different ways on how you can make
' one.

' A timer is used instead of the mouse_move event
' when getting the mouse position
' because the pixels under the mouse might change
' without you moving the mouse.

' To make this work, just hold the mouse down on one
' of the pictureboxes and drag it.

Option Explicit

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const SWP_NOMOVE = 2
Private Const SWP_NOSIZE = 1
Private Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2

Private Const SRCCOPY = &HCC0020

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Sub Command1_Click()

End Sub

Private Sub Form_Load()
' set this window on top
Call SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Change the cursor to an up arrow
    Picture1.MousePointer = 10
    Timer1.Enabled = True
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim red As String, green As String, blue As String
    
    ' Get the red, green, and blue color amounts
    ' from the picture backcolor.
    red = CStr(Picture1.BackColor And 255)
    green = CStr(Picture1.BackColor \ 256 And 255)
    blue = CStr(Picture1.BackColor \ 65536 And 255)
    
    Timer1.Enabled = False
    ' Change the cursor back to normal
    Picture1.MousePointer = 0
    ' set the color info in the textbox
    Text1.Text = "Color = "
    Text1.Text = Text1.Text + "RGB(" & red & ", " & green & ", " & blue & ")"
End Sub

Private Sub Picture2_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Change the cursor to an up arrow
    Picture2.MousePointer = 10
    Timer2.Enabled = True
End Sub

Private Sub Picture2_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim red As String, green As String, blue As String
    
    ' Get the red, green, and blue color amounts
    ' from the picture backcolor.
    red = CStr(Picture2.BackColor And 255)
    green = CStr(Picture2.BackColor \ 256 And 255)
    blue = CStr(Picture2.BackColor \ 65536 And 255)
    
    Timer2.Enabled = False
    ' Change the cursor back to normal
    Picture2.MousePointer = 0
    ' set the color info in the textbox
    Text1.Text = "Color = "
    Text1.Text = Text1.Text + "RGB(" & red & ", " & green & ", " & blue & ")"
End Sub

Private Sub Timer1_Timer()
    Dim DeskTopWin As Long, DeskTopDC As Long
    Dim C As POINTAPI
    ' Get the position of the cursor and store
    ' the x and y values in the C variable
    Call GetCursorPos(C)
    ' find the desktop
    DeskTopWin = FindWindow("#32769", vbNullString)
    ' get it's dc
    DeskTopDC = GetDC(DeskTopWin)
    ' get the pixel and set the picture's
    ' backcolor to it.
    Picture1.BackColor = GetPixel(DeskTopDC, C.X, C.Y)
End Sub

Private Sub Timer2_Timer()
    Dim CursorPos As POINTAPI
    Dim TheX As Integer, TheY As Integer
    Dim MHouse As RECT
    
    ' Get the size and position of the picture2
    ' picturebox
    Call GetWindowRect(Picture2.hwnd, MHouse)
    ' Get the position of the cursor and store
    ' the x and y values in the C variable
    Call GetCursorPos(CursorPos)
    ' Alter the x and y positions to go with
    ' the picturebox's position
    TheX = CursorPos.X - MHouse.Left
    TheY = CursorPos.Y - MHouse.Top
    ' Clear the picturebox
    Picture2.Cls
    ' Set the first few pixels in the picture2
    ' picturebox to the pixel that the mouse
    ' is over.
    Call BitBlt(Picture2.hdc, 0, 0, 10, 10, Picture2.hdc, TheX, TheY, SRCCOPY)
    ' Make the backcolor of the picturebox equal
    ' to the color of the pixels you just set.
    Picture2.BackColor = Picture2.Point(1, 1)
End Sub
